package org.rcisoft.business.bbanner.service;




import org.rcisoft.business.bbanner.dto.AddOrUpdateDTO;
import org.rcisoft.business.bbanner.dto.BannerInfoRspDTO;
import org.rcisoft.business.bbanner.dto.FindBannerPaginDTO;
import org.rcisoft.business.bbanner.dto.TopDownDTO;
import org.rcisoft.business.bchapter.entity.BChapter;
import org.rcisoft.core.aop.PageUtil;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.business.bbanner.entity.BBanner;

import java.util.List;

public interface BBannerService {

    /**
     * 插入/修改
     * @author: zhangqingle
     * @param addOrUpdateDTO
     * @return
     */
    PersistModel persist(AddOrUpdateDTO addOrUpdateDTO);

    /**
     * 逻辑删除
     * @author: zhangqingle
     * @param id
     * @return
     */
    PersistModel removeBanner(String id);

    /**
     * 唯一查找
     * @author: zhangqingle
     * @param businessId
     * @return
     */
    BBanner selectOne(String businessId);

    /**
     * 获取Banner分页
     * @author: zhangqingle
     * @param pageUtil
     * @param model
     * @return
     */
    List<BBanner> queryBannerByPagination(PageUtil pageUtil, FindBannerPaginDTO model);


    /**
     * @author: jiangpengpeng
     * @description: TODO
     * @date: 2019/9/26 16:25
     * @param bannerOrderMap
     * @return
     */
    int updateBannerOrder(String bannerOrderMap);

}
