package org.rcisoft.business.bchapter.service;


import org.rcisoft.business.bchapter.dto.*;
import org.rcisoft.business.bchapter.entity.BChapter;
import org.rcisoft.business.bchapter.vo.StudentChapterScoreVO;
import org.rcisoft.business.bfile.dto.uploadDTO;
import org.rcisoft.business.bfile.entity.BFile;
import org.rcisoft.core.aop.PageUtil;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.sys.user.bean.CurUser;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;
import java.util.Map;


public interface BChapterService{
    /**
    * 根据主键唯一查找
    * @param businessId
    * @return
    */
    BChapter selectOne(String businessId);

    /**
    * 根据条件分页查找
    * @param pageUtil
    * @param model
    * @return
    */
    List<QueryChapterListResDTO> queryBChaptersByPagination(PageUtil pageUtil, QueryChapterListDTO model,String corpId);

    /**
     * 根据章节id查找学生分数信息
     * @param dto
     * @return
     */
    List<StudentChapterScoreVO> queryScoreListByChapterIdByPagination(PageUtil pageUtil, QueryScoreListDTO dto);

    /**
    * 根据条件查找全部
    * @param model
    * @return
    */
    List<QueryChapterListResDTO> queryBChapters(QueryChapterListDTO model,String corpId);

    /**
    * 根据条件查找全部
    * @param
    * @return
    */
    Map queryBChaptersWithProgress(String lessonId, CurUser curUser);


    /**
     *
     * @param model
     * @param corpId
     * @return
     */
    List<QueryChapterListResDTO> queryChapterListResDTO(QueryChapterListDTO model, String corpId);

    /**
    * 插入
    * @param chapterDTO
    * @return
    */
    PersistModel persist(ChapterDTO chapterDTO, String corpId, uploadDTO dto);

    /**
     * 修改
     * @param model
     * @return
     */
    PersistModel update(BChapter model);

    /**
    * 逻辑删除
    * @param id
    * @return
    */
    PersistModel removeBChapter(String id,String userId);

    /**
     * 文件转换
     * @param chapterId
     * @return
     */
    String changeFileToPdf(String chapterId);

    /**
     * 文件转换
     * @param bFile
     * @return
     */
    String changeFileToPdfAtView(BFile bFile);

    /**
     * 下载文件
     * @param bFile
     * @return
     */
    String getDownLoadUrl(BFile bFile);

    /**
     * 打分
     * @param scoreInfoDTOS
     * @return
     */
    void markScore(List<ScoreInfoDTO> scoreInfoDTOS);

    /**
     * 根据学生id和课程id获取该学生的课程章节分数列表
     * @param slid
     * @param stuid
     * @return
     */
    List<StuScoreDTO> queryScoreListBySlIdAndStuId(String slid, String stuid);


    /**
     * 打回重做
     * @param chapterId
     * @param studentCode
     */
    void deleteScoerInfo(String chapterId, String studentCode);


    /*
    * 根据学生ID和章节ID查询该节的学习情况
    * */
    ScoreInfoDTO getChapInfoById(ScoreInfoDTO scoreInfoDTO) throws Exception;

    int updateChapterState(BChapter bChapter);

    int updateAllChapterState(String slId);

    int updateTopChapter(BChapter bChapter);

    int updateDownChapter(BChapter bChapter);

}
