package org.rcisoft.business.bcourse.entity;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.validator.constraints.Length;
import org.rcisoft.business.bcourse.dao.BCourseRepository;
import org.rcisoft.core.entity.IdEntity;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.List;

@Entity
@Table(name = "b_course")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class BCourse extends IdEntity<BCourse> {

    @ApiModelProperty(value = "章节名")
//    @Length(min = 1,max = 64,message = "长度最小为1,最大为50")
    private String cName;

    @ApiModelProperty(value = "父级id")
    @Length(min = 1,max = 64,message = "长度最小为1,最大为50")
    private String pid;

    private  int sort;

    @ApiModelProperty(value = "章节等级")
    @Length(min = 1,max = 64,message = "长度最小为1,最大为50")
    private  String courseLevel;

    @Transient
    private List<BCourseRepository> childList;

}
