package org.rcisoft.business.bfile.controller;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.io.IOUtils;
import org.rcisoft.business.bfile.dto.uploadDTO;
import org.rcisoft.business.bfile.entity.BFile;
import org.rcisoft.business.bfile.service.BFileService;
import org.rcisoft.common.component.Global;
import org.rcisoft.common.controller.PaginationController;
import org.rcisoft.common.model.GridModel;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.exception.ServiceException;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.rcisoft.core.result.ResultServiceEnums;
import org.rcisoft.core.util.UserUtil;
import org.rcisoft.sys.user.bean.CurUser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.util.List;
import java.util.Map;

/**
* Created by gaowenfneg on 2017-10-9 14:34:56.
*/
@Api(tags = "04 文件")
@RestController
@RequestMapping("/bfile")
public class BFileController extends PaginationController<BFile> {
    @Autowired
    private BFileService bFileService;
    @Autowired
    private Global global;

    @ApiOperation(value="401 上传文件（弃用）", notes="上传文件（弃用）")
    @ApiImplicitParams({@ApiImplicitParam(name = "type", value = "0视频 1音频 2ppt 3pdf 4附件", required = true, dataType = "varchar"),
            @ApiImplicitParam(name = "file", value = "视频文件", required = true, dataType = "MultipartFile")})
    @PostMapping(value = "/upload")
    public Result uploadVideo(String type, MultipartFile file) {
        uploadDTO data = bFileService.uploadVideoToServer(file, type);
            return Result.builder(new PersistModel(1),
                    "上传成功",
                    MessageConstant.MESSAGE_ALERT_ERROR,
                    data);
    }

}

