package org.rcisoft.business.bfile.entity;

import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.validator.constraints.Length;
import org.rcisoft.core.entity.IdEntity;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.validation.constraints.NotBlank;

/**
* Created with gaowenfneg on 2017-10-9 14:34:56.
*/
@Entity
@Table(name = "b_file")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class BFile extends IdEntity<BFile> {

    private static final long serialVersionUID = 5501554322621964535L;
    /*视频名称*/
//    @Length(min = 1,max = 256,message = "长度最小为1,最大为200")
//    @NotBlank
    @ApiModelProperty(value = "文件名")
    private String fileName;

    /*视频地址*/
//    @Length(min = 1,max = 256,message = "长度最小为1,最大为200")
//    @NotBlank
    @ApiModelProperty(value = "地址(预览时传)")
    private String videoUrl;

    /*0视频 1音频 2ppt 3pdf 4附件*/
    @ApiModelProperty(value = "类型(预览时传)")
    private String type;

//    @Length(min = 1,max = 256,message = "长度最小为1,最大为200")
//    @NotBlank
    private String fileUrl;

//    @Length(min = 1,max = 64,message = "长度最小为1,最大为50")
//    @NotBlank
    @ApiModelProperty(value = "课程ID(预览时传)")
    private String lessonId;//课程ID

//    @Length(min = 1,max = 64,message = "长度最小为1,最大为50")
//    @NotBlank
    @ApiModelProperty(value = "节ID")
    private String chapterId;//节ID

    //文件大小
//    @Length(min = 1,max = 15,message = "长度最小为1,最大为15")
    @ApiModelProperty(value = "文件大小")
    private String fileSize;

    @ApiModelProperty(value = "文件时长")
    private String fileTime;

    private String userId;

    private String corpId;

}

