package org.rcisoft.business.bfile.util;

import java.io.File;

import it.sauronsoftware.jave.Encoder;
import it.sauronsoftware.jave.EncoderException;
import it.sauronsoftware.jave.MultimediaInfo;
import lombok.extern.slf4j.Slf4j;
import org.rcisoft.core.exception.ServiceException;
import org.rcisoft.core.result.ResultCode;
@Slf4j
public class GetVideoTime {
    /**
     * 获取音频/视频的时长
     * @param path
     * @return
     */
    public String getVideoDuration(String path) {
        // get file in specified "path"
        File file = new File(path);

        Encoder encoder = new Encoder();
        MultimediaInfo multimediaInfo;

        long totalTime = 0L;
        long duration = 0L;

        try {
            multimediaInfo = encoder.getInfo(file);
            duration = multimediaInfo.getDuration();
            totalTime += duration;
        } catch (EncoderException e) {
            throw new ServiceException(ResultCode.ERROR.getCode(),e.getMessage());
        }

        // long --> hh:mm: calculate the time manually
        String time = totalTime / (3600 * 1000) + ":" + totalTime % (3600 * 1000) / (60 * 1000) + ":" + totalTime % (3600 * 1000) % (60 * 1000) / 1000;

        return time;
    }

    public static void main(String[] args) {
//        String filePath = "E:\\迅雷下载\\CHS.mp4";
        String filePath = "F:\\CloudMusic\\不要说话.mp3";

        GetVideoTime getVideoTime = new GetVideoTime();
        log.info( getVideoTime.getVideoDuration(filePath));
    }
}