package org.rcisoft.business.blabel.dao;

import org.apache.ibatis.annotations.*;
import org.rcisoft.business.blabel.entity.BLabel;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface BLabelRepository extends BaseMapper<BLabel> {

//    查询所有数据
    @Select("<script>SELECT * FROM b_label where del_flag != 1 and flag = 1 " +

            " and corp_id = #{corpId}" +

            "<if test=\"lName!=null and lName != ''\"> and l_name like CONCAT('%',#{lName},'%') </if>" +
            "order by create_date desc </script>")
    @ResultMap(value = "BaseResultMap")
    List<BLabel> queryBlabels(@Param("lName") String lName,@Param("corpId")String corpId);

//    增加标签是检查标签名重复
    @Select("<script>select count(0) from b_label " +
            "where l_name = #{lName} " +
            "AND del_flag='0' and flag='1' " +
            "<if test=\"businessId!=null and businessId != ''\"> and business_id != #{businessId} </if>" +
            "and corp_id = #{corpId}</script>")
    int checknameByName(@Param("lName")String lName,@Param("businessId")String businessId,@Param("corpId") String corpId);

//    逻辑删除标签
    @Update("UPDATE b_label SET del_flag='1' where business_id = #{businessId}")
    int removeLabel(@Param("businessId") String id);

}
