package org.rcisoft.business.blesson.dao;

import org.apache.ibatis.annotations.*;
import org.rcisoft.business.blabel.entity.BLabel;
import org.rcisoft.business.blesson.dto.*;
import org.rcisoft.business.blesson.entity.BLesson;
import org.rcisoft.business.blesson.entity.BLessonPerson;
import org.rcisoft.core.base.BaseMapper;
import org.rcisoft.sys.user.bean.CurUser;
import org.springframework.stereotype.Repository;

import javax.xml.crypto.Data;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Repository
public interface BLessonPersonRepository extends BaseMapper<BLessonPerson> {

    //我学习的课程
    @Select("<script> select blp.*,bl.lesson_name lessonName,bl.default_url defaultUrl,bl.person_number personNumber, " +
            " bl.class_hour classHour,bl.discuss_number discussNumber ,bl.lecturer_id lecturerId, bl.lesson_type " +
            " lessonType,bl.course_time courseTime,bl.release_state releaseState  " +
            ",su.name lecturerName " +
            " from b_lesson_person blp " +
            " left join b_lesson bl on blp.lesson_id = bl.business_id " +
            " left join s_user su on su.business_id = bl.lecturer_id " +
            " left join b_course bc on bc.business_id = bl.course_id " +
            " where blp.del_flag != 1 and blp.flag = 1 " +
            " and  bl.del_flag != 1 and bl.flag = 1 " +
            " and  bl.del_flag != 1 and bl.flag = 1 " +
//            " and bl.release_state = '2' " +
            " and blp.person_id = #{param.userId} " +

            " and bl.corp_id = #{param.corpId} " +

            " <if test= \" param.isFinish != null and param.isFinish != ''\">and blp.is_finish = #{param.isFinish} </if> " +
            " <if test= \" param.lessonType !=null and param.lessonType != ''\">and bl.lesson_type = #{param.lessonType} </if> " +
//            " <if test= \" param.startFlag !=null and param.startFlag != ''\">and blp.start_flag = #{param.startFlag} </if> " +
            " <if test= \" param.isAppoint !=null and param.isAppoint != ''\">and blp.is_appoint = #{param.isAppoint} </if> " +
            " <if test= \" param.trainIsSign !=null and param.trainIsSign != ''\">and blp.train_is_sign = #{param.trainIsSign} </if> " +
            " order by blp.update_date desc" +
            "" +
            "</script>")
    @ResultMap(value = "BaseResultMap")
    List<BLesson> queryLearnBLessons(@Param("param") ILearnLessonDTO param);



    // 退出课程
    @Update("update b_lesson_person set del_flag = 1 where business_id = #{id}")
    int quit(String id);

    //查询线上课程学员追踪图表
    @Select("<script> select  " +
            "(select lesson_name from b_lesson where business_id = #{param.lessonId}) LessonTitle, " +

            "(select count(*) from b_lesson_person blp " +
            " left join s_user su on blp.person_id = su.business_id " +
            " where " +
            " blp.del_flag != 1 and blp.flag = 1 " +
//            " and su.del_flag != 1 and su.flag = 1 " +
            " <if test= \" param.isAppoint != null and param.isAppoint != ''\">and blp.is_appoint = #{param.isAppoint} </if> " +
            " and blp.lesson_id = #{param.lessonId}) countAll, " +

            "(select count(*) from b_lesson_person blp " +
            " left join s_user su on blp.person_id = su.business_id " +
            " where " +
            " blp.del_flag != 1 and blp.flag = 1 " +
//            " and su.del_flag != 1 and su.flag = 1 " +
            " and blp.is_finish = 0 " +
            " <if test= \" param.isAppoint != null and param.isAppoint != ''\">and blp.is_appoint = #{param.isAppoint} </if> " +
            " and blp.lesson_id = #{param.lessonId}) countNotStart, " +

            "(select count(*) from b_lesson_person blp " +
            " left join s_user su on blp.person_id = su.business_id " +
            "  where " +
            " blp.del_flag != 1 and blp.flag = 1 " +
//            " and su.del_flag != 1 and su.flag = 1 " +
            " and blp.is_finish = 1 " +
            " <if test= \" param.isAppoint != null and param.isAppoint != ''\">and blp.is_appoint = #{param.isAppoint} </if> " +
            " and blp.lesson_id = #{param.lessonId}) countOngoing, " +

            "(select count(*) from b_lesson_person blp " +
            " left join s_user su on blp.person_id = su.business_id " +
            " where " +
            " blp.del_flag != 1 and blp.flag = 1 " +
//            " and su.del_flag != 1 and su.flag = 1 " +
            " and blp.is_finish = 2 " +
            " <if test= \" param.isAppoint != null and param.isAppoint != ''\">and blp.is_appoint = #{param.isAppoint} </if> " +
            " and blp.lesson_id = #{param.lessonId}) countFinish" +
            " </script>")
    StudentTrackingChartRspDTO studentTrackingChart(@Param("param") StudentTrackingChartDTO param);

    //学员追踪
    @Select("<script> select blp.business_id businessId," +
            "  blp.person_id personId, " +
            "  bl.lesson_name LessonTitle , su.name personName, " +
            "  blp.is_appoint isAppoint , blp.is_finish isFinish ," +
            "  blp.learn_progress learnProgress ," +
            "  if(blp.is_appoint = 0, blp.apply_date, ba.update_date) appointDate, " +
//            "  ba.create_date appointDate ," +
            "  blp.finish_date finishDate , " +
            "  blp.apply_date applyDate , " +
            "  blp.sign_date signDate , " +
            "  blp.train_is_sign trainIsSign  " +
            "from b_lesson_person blp left join b_lesson bl on blp.lesson_id = bl.business_id " +
            "left join s_user su on blp.person_id = su.business_id " +
            "left join b_appoint ba on ba.business_id = blp.appoint_id " +
            "and ba.del_flag != 1 and ba.flag = 1 " +
//            "left join b_appoint ba on ba.lesson_id = bl.business_id " +
            "where blp.del_flag != 1 and blp.flag = 1 " +
            "and bl.del_flag != 1 and bl.flag = 1 " +
//            "and su.del_flag != 1 and su.flag = 1 " +

            "and bl.corp_id = #{param.corpId} "+
//            "and blp.corp_id = #{param.corpId} "+
//            "and su.corp_id = #{param.corpId} "+

            "and bl.business_id = #{param.lessonId} "+
            "<if test= \" param.isAppoint != null and param.isAppoint != ''\">and blp.is_appoint = #{param.isAppoint} </if> " +
            "<if test= \" param.userIdsInDepart != null and param.userIdsInDepart.size()>0 \">and blp.person_id in " +
            "  <foreach item='item' index='index' collection='param.userIdsInDepart' open='(' separator=',' close=')'> #{item} </foreach> " +
            " </if> " +
            "<if test= \" param.personName != null and param.personName != ''\">and su.name like CONCAT('%',#{param.personName},'%') </if> " +
            "<if test= \" param.isFinish != null and param.isFinish != ''\">and blp.is_finish = #{param.isFinish} </if> " +
            "<if test= \" param.trainIsSign != null and param.trainIsSign != ''\">and blp.train_is_sign = #{param.trainIsSign} </if> " +
            "<if test= \" param.appointDateSort !=null and param.appointDateSort !='' and param.appointDateSort =='0'.toString()\">  ORDER BY appointDate DESC  </if> "+
            "<if test= \" param.appointDateSort !=null and param.appointDateSort !='' and param.appointDateSort =='1'.toString()\">  ORDER BY appointDate ASC </if> "+
            "<if test= \" param.finishDateSort !=null and param.finishDateSort !='' and param.finishDateSort =='0'.toString()\">  ORDER BY blp.finish_date DESC  </if> "+
            "<if test= \" param.finishDateSort !=null and param.finishDateSort !='' and param.finishDateSort =='1'.toString()\">  ORDER BY blp.finish_date ASC </if> "+
            "<if test= \" param.applyDateSort !=null and param.applyDateSort !='' and param.applyDateSort =='0'.toString()\">  ORDER BY blp.create_date DESC  </if> "+
            "<if test= \" param.applyDateSort !=null and param.applyDateSort !='' and param.applyDateSort =='1'.toString()\">  ORDER BY blp.create_date ASC </if> "+
            "<if test= \" param.signDateSort !=null and param.signDateSort !='' and param.signDateSort =='0'.toString()\">  ORDER BY blp.sign_date DESC  </if> "+
            "<if test= \" param.signDateSort !=null and param.signDateSort !='' and param.signDateSort =='1'.toString()\">  ORDER BY blp.sign_date ASC </if> "+
            "</script>")
    List<StudentTrackingRspDTO> studentTrackingByPagination(@Param("param") StudentTrackingDTO param);


    /**
     * 查询指派id
     * @param param
     * @return
     */
    @Select("<script>select appoint_id from b_lesson_person where business_id = #{businessId}</script>")
    String selectAppointIdById(CancelAppointDTO param);

    /**
     * 查询指派id
     * @param param
     * @return
     */
    @Select("<script>select is_finish from b_lesson_person where business_id = #{businessId}</script>")
    String selectIsFinish(CancelAppointDTO param);

    /**
     * 根据课程id查询学生id
     * @param param
     * @return
     */
    @Select("<script>select business_id,person_id,lesson_id from b_lesson_person where 1=1 " +
//            "and del_flag = 0 and flag = 1 " +
            "AND person_id IN" +
            "<foreach item='item' collection='appointPersonList' open='(' close=')' separator=','> " +
            "#{item} " +
            "</foreach>" +
            "and lesson_id = #{lessonId}</script>")
    @ResultMap(value = "BaseResultMap")
    List<BLessonPerson> selectPersonIdByLessonId(AppointLessonDTO param);

    @Select("<script>select business_id,person_id,lesson_id , learn_progress, is_finish, finish_date from b_lesson_person where 1=1 " +
            "and lesson_id = #{lessonId}</script>")
    @ResultMap(value = "BaseResultMap")
    List<BLessonPerson> selectByLessonId(@Param("lessonId") String lessonId);

    /**
     * 按课程id删除指派未开始
     * @param param
     * @return
     */
    @Update("<script> update b_lesson_person blp left join b_appoint ba" +
            " on blp.appoint_id = ba.business_id " +
            " and ba.del_flag != 1 and ba.flag = 1 " +
            "  <set>"+
            "       <if test=\"param.isAppoint != null and param.isAppoint != ''\">blp.is_appoint=#{param.isAppoint},</if>" +
            "       <if test=\"param.appointId != null and param.appointId != ''\">blp.appoint_id=#{param.appointId},</if>" +
            "       blp.flag = '0' ," +
            "       blp.apply_date = #{param.applyDate} " +
            "  </set>"+
            " where 1=1 " +
            " and blp.is_finish = '0' " +
            " and ba.lesson_id = #{param.lessonId} " +
            "</script>")
    int deleteNotStartByLessonId(@Param("param") BLessonPerson param);

    /**
     * 已学习的取消指派
     * @param param
     * @return
     */
    @Update("<script> update b_lesson_person blp left join b_appoint ba" +
            " on blp.appoint_id = ba.business_id " +
            " and ba.del_flag != 1 and ba.flag = 1 " +
            "  <set>"+
            "    <if test=\"updateBy != null and updateBy != ''\">ba.update_by=#{updateBy},</if>"+
            "    <if test=\"updateDate != null \">ba.update_date=#{updateDate},</if>"+
            "    <if test=\"isAppoint != null and isAppoint != ''\">blp.is_appoint=#{isAppoint},</if>"+
            "   blp.appoint_id=#{appointId},"+
            "  </set>"+
            " where 1=1 " +
            " and ba.lesson_id = #{lessonId} " +
            "</script>")
    int cancelAppointByPersons(BLessonPerson param);


    /**
     * 按Id批量更新
     * @param param
     * @return
     */
    @Update("<script>" +
            " update b_lesson_person " +
            "  <set> " +
            "    <if test=\"param.updateBy != null and param.updateBy != ''\">update_by=#{param.updateBy},</if>"+
            "    <if test=\"param.updateDate != null \">update_date=#{param.updateDate},</if>"+
            "    <if test=\"param.delFlag != null and param.delFlag != '' \">del_flag=#{param.delFlag},</if>"+
            "    <if test=\"param.flag != null and param.flag != '' \">flag=#{param.flag},</if> " +
            "   apply_date = ifnull(apply_date, #{nowDate}), "+
            "   appoint_id=#{param.appointId}, " +
            "   is_appoint=#{param.isAppoint} " +
            "  </set> " +
            "    where 1=1 " +
            "    and lesson_id = #{param.lessonId} " +
            "    and person_id in  " +
            " <foreach item='item' index='index' collection='ids' open='(' separator=',' close=')'> #{item} </foreach>" +
            "</script>")
    int updateList(@Param("param") BLessonPerson param, @Param("ids")List<String> ids, @Param("nowDate") Date nowDate);

    @Insert("<script>" +
            " insert into b_lesson_person(" +
            " business_id,create_by,create_date,update_by,update_date, " +
            " del_flag,flag,remarks,person_id,lesson_id, " +
            " learn_progress,is_finish,appoint_id, " +
            " is_appoint, is_apply, train_is_sign,apply_date,sign_date) " +
            " values " +
            " <foreach collection='param' index='index' item='item' separator=','>(" +
            "  #{item.businessId}, #{item.createBy},#{item.createDate},#{item.updateBy},#{item.updateDate}, " +
            "  #{item.delFlag}, #{item.flag},#{item.remarks},#{item.personId},#{item.lessonId}, " +
            "  #{item.learnProgress}, #{item.isFinish}, #{item.appointId}, " +
            "  #{item.isAppoint},#{item.isApply},#{item.trainIsSign},#{item.applyDate},#{item.signDate} ) " +
            " </foreach>" +
            "</script>")
    int insertList(@Param("param") List<BLessonPerson> param);

    /**
     * 根据课程id PersonId查询
     */
    @Select("<script>select * from b_lesson_person where 1=1 " +
            "and del_flag = 0 and flag = 1 " +
            "AND person_id = #{userId} " +
            "and lesson_id = #{lessonId}</script>")
    @ResultMap(value = "BaseResultMap")
    List<BLessonPerson> selectByPersonAndLesson(AddMyLearnLessonDTO param);

    /**
     * 根据课程id PersonId查询(包括已删除,停用的)
     */
    @Select("<script>select * from b_lesson_person where 1=1 " +
            "AND person_id = #{userId} " +
            "and lesson_id = #{lessonId}</script>")
    @ResultMap(value = "BaseResultMap")
    List<BLessonPerson> selectRealByPersonAndLesson(AddMyLearnLessonDTO param);


    @Insert("<script>" +
            " insert into b_lesson_person(" +
            " business_id,create_by,create_date,update_by,update_date, " +
            " del_flag,flag,remarks,person_id,lesson_id, " +
            " learn_progress,is_finish,is_collect, " +
            " is_appoint, apply_date) " +
            " values " +
            "  (#{param.businessId}, #{param.createBy},#{param.createDate},#{param.updateBy},#{param.updateDate}, " +
            "  #{param.delFlag}, #{param.flag},#{param.remarks},#{param.personId},#{param.lessonId}, " +
            "  #{param.learnProgress}, #{param.isFinish},#{param.isCollect}," +
            "  #{param.isAppoint}, #{param.applyDate}) " +
            "</script>")
    int insertBLessonPerson(@Param("param") BLessonPerson param);

    @Select("<script>select * from b_lesson_person where 1=1 " +
            "and business_id = #{businessId}</script>")
    @ResultMap(value = "BaseResultMap")
    BLessonPerson selectById(String businessId);

    /**
     * 查询该用户在此培训中不删除的状态
     * @param lessonId
     * @param personId
     * @return
     */
    @Select("select * from b_lesson_person where lesson_id  = #{lessonId} and person_id = #{personId} and del_flag != 1 ")
    @ResultMap(value = "BaseResultMap")
    BLessonPerson getAppointInTraining(@Param("lessonId")String lessonId ,@Param("personId")String personId );
    /**
     * 查询该用户在此培训中包含删除的状态
     * @param lessonId
     * @param personId
     * @return
     */
    @Select("select * from b_lesson_person where lesson_id  = #{lessonId} and person_id = #{personId} ")
    @ResultMap(value = "BaseResultMap")
    BLessonPerson getRelInBLessonPerson(@Param("lessonId")String lessonId ,@Param("personId")String personId );


    @Select("<script>select * " +
            " from b_lesson_person " +
            " where 1=1 " +
            "and del_flag = 0 and flag = 1 " +
//            "and su.del_flag = 0 and su.flag = 1 " +
            "<if test= \" param.isApply != null and param.isApply != ''\">and is_apply = #{param.isApply} </if> " +
            "<if test= \" param.trainIsSign != null and param.trainIsSign != ''\">and train_is_sign = #{param.trainIsSign} </if> " +
            "and lesson_id = #{param.lessonId} " +
            "order by is_appoint desc</script>")
    @ResultMap(value = "BaseResultMap")
    List<BLessonPerson> trainPersons(@Param("param") FindTrainPersonDTO param);

    /**
     * 用户在表中有未删除的数据且未报名
     * 更新 报名状态、报名时间、培训状态
     * @return
     */
    @Update("update b_lesson_person set apply_date=#{applyDate},is_apply =#{isApply},train_is_sign = #{trainIsSign} " +
            "where lesson_id= #{lessonId} and person_id=#{personId} and del_flag != 1 ")
    int updateLessonPersonByUserId(BLessonPerson lessonPerson);


    @Select("select count(0) x ,(select max_apply_person from b_lesson where business_id = #{lessonId} ) y " +
            "from b_lesson_person where del_flag='0' and flag = '1' and lesson_id = #{lessonId} ")
    Map<String,Object> selecTraningNum(@Param("lessonId") String lessonId);


    @Update({"<script>",
            "update b_lesson_person",
            "  <set>",
            "   train_is_sign = 1 ",
            "  </set>",
            "where 1=1 ",
            " and lesson_id in  ",
            " <foreach item='item'  collection='lessonIds' open='(' separator=',' close=')'> #{item} </foreach> " ,
            "and train_is_sign != 2 ",
            "</script>"})
    int updateByLessonIds(@Param("lessonIds") List<String> lessonIds);


    // 用户管理 - 课程情况
    @Select("<script> select blp.business_id businessId," +
            "  bl.lesson_name LessonTitle ,  " +
            "  bl.class_hour classHour , " +
            "  blp.is_appoint isAppoint , " +
            "  blp.is_finish isFinish , " +
            "  blp.learn_progress learnProgress , " +
            "  case when now() &lt; SUBDATE(bl.train_start_date,interval bl.train_sign_time MINUTE)  then 0 when now() BETWEEN  SUBDATE(bl.train_start_date,interval bl.train_sign_time MINUTE) and bl.train_over_date then 1 when now() &gt; bl.train_over_date then 2 end as trainState, " +
//            "  case when now() &lt; bl.train_start_date then 0 when now() BETWEEN bl.train_start_date and bl.train_over_date then 1 when now() &gt; bl.train_over_date then 2 end as trainState, "+
            "  if(blp.is_appoint = 0, blp.apply_date, ba.update_date) appointDate, " +
            "  blp.finish_date finishDate , " +
            "  blp.apply_date applyDate , " +
            "  blp.sign_date signDate , " +
            "  blp.train_is_sign trainIsSign " +
            "from b_lesson_person blp left join b_lesson bl on blp.lesson_id = bl.business_id " +
            "left join s_user su on blp.person_id = su.business_id " +
            "left join b_appoint ba on ba.business_id = blp.appoint_id " +
            "and ba.del_flag != 1 and ba.flag = 1 " +
            "where blp.del_flag != 1 and blp.flag = 1 " +
            "and bl.del_flag != 1 and bl.flag = 1 " +

            "and bl.corp_id = #{param.corpId} "+

            "and blp.person_id = #{param.userId} "+
            "<if test= \" param.isAppoint != null and param.isAppoint != ''\">and blp.is_appoint = #{param.isAppoint} </if> " +
            "<if test=\" param.lessonTitle !=null and param.lessonTitle != ''\">and bl.lesson_name like CONCAT('%',#{param.lessonTitle},'%')</if>" +
            "<if test= \" param.isFinish != null and param.isFinish != ''\">and blp.is_finish = #{param.isFinish} </if> " +
            "<if test= \" param.trainIsSign != null and param.trainIsSign != ''\">and blp.train_is_sign = #{param.trainIsSign} </if> " +
            "<if test= \" param.lessonType != null and param.lessonType != ''\">and bl.lesson_type = #{param.lessonType} </if> " +

            "<if test= \" param.learnProgressMin != null and param.learnProgressMin != ''\">and CAST(blp.learn_progress AS UNSIGNED) &gt;= #{param.learnProgressMin} </if> " +
            "<if test= \" param.learnProgressMax != null and param.learnProgressMax != ''\">and CAST(blp.learn_progress AS UNSIGNED) &lt;= #{param.learnProgressMax} </if> " +
            "<if test= \" param.appointStartDate != null \">and ba.update_date &gt;= #{param.appointStartDate} </if> " +
            "<if test= \" param.appointEndDate != null \">and ba.update_date &lt;= #{param.appointEndDate} </if> " +
            "<if test= \" param.finishStartDate != null \">and blp.finish_date &gt;= #{param.finishStartDate} </if> " +
            "<if test= \" param.finishEndDate != null \">and blp.finish_date &lt;= #{param.finishEndDate} </if> " +
            "<if test= \" param.applyStartDate != null \">and blp.apply_date &gt;= #{param.applyStartDate} </if> " +
            "<if test= \" param.applyEndDate != null \">and blp.apply_date &lt;= #{param.applyEndDate} </if> " +
            "<if test= \" param.signStartDate != null \">and blp.sign_date &gt;= #{param.signStartDate} </if> " +
            "<if test= \" param.signEndDate != null \">and blp.sign_date &lt;= #{param.signEndDate} </if> " +

            "<if test= \" trainTypeSelStr != null and trainTypeSelStr != ''\">${trainTypeSelStr} </if> " +

            "<if test= \" param.appointDateSort !=null and param.appointDateSort !='' and param.appointDateSort =='0'.toString()\">  ORDER BY appointDate DESC  </if> "+
            "<if test= \" param.appointDateSort !=null and param.appointDateSort !='' and param.appointDateSort =='1'.toString()\">  ORDER BY appointDate ASC </if> "+
            "<if test= \" param.finishDateSort !=null and param.finishDateSort !='' and param.finishDateSort =='0'.toString()\">  ORDER BY blp.finish_date DESC  </if> "+
            "<if test= \" param.finishDateSort !=null and param.finishDateSort !='' and param.finishDateSort =='1'.toString()\">  ORDER BY blp.finish_date ASC </if> "+
            "<if test= \" param.applyDateSort !=null and param.applyDateSort !='' and param.applyDateSort =='0'.toString()\">  ORDER BY appointDate DESC  </if> "+
            "<if test= \" param.applyDateSort !=null and param.applyDateSort !='' and param.applyDateSort =='1'.toString()\">  ORDER BY appointDate ASC </if> "+
            "<if test= \" param.signDateSort !=null and param.signDateSort !='' and param.signDateSort =='0'.toString()\">  ORDER BY blp.sign_date DESC  </if> "+
            "<if test= \" param.signDateSort !=null and param.signDateSort !='' and param.signDateSort =='1'.toString()\">  ORDER BY blp.sign_date ASC </if> "+
            "<if test= \" param.learnProgressSort !=null and param.learnProgressSort !='' and param.learnProgressSort =='0'.toString()\">  ORDER BY CAST(learnProgress AS UNSIGNED) DESC </if> "+
            "<if test= \" param.learnProgressSort !=null and param.learnProgressSort !='' and param.learnProgressSort =='1'.toString()\">  ORDER BY CAST(learnProgress AS UNSIGNED) ASC </if> "+
            "<if test= \" param.classHourSort !=null and param.classHourSort !='' and param.classHourSort =='0'.toString()\">  ORDER BY CAST(classHour AS UNSIGNED) DESC </if> "+
            "<if test= \" param.classHourSort !=null and param.classHourSort !='' and param.classHourSort =='1'.toString()\">  ORDER BY CAST(classHour AS UNSIGNED) ASC </if> "+
            "</script>")
    List<StudentTrackingRspDTO> userManageLesson(@Param("param") UserLessonDTO userLessonDTO, @Param("trainTypeSelStr")String trainTypeSelStr);


    @Select("<script>" +
            " select b.p_name paperName, b.p_duration examTime,concat(b.p_pass_score ,'/',b.p_total_score) paperScore, " +
            " a.e_status  paperStatus , (CASE WHEN a.e_score >= b.p_pass_score THEN '通过' ELSE '未通过' END) examResult ,a.e_score score, " +
            " TIMESTAMPDIFF(MINUTE, a.e_starttime, a.e_endtime) timeCost," +
            " a.e_starttime examStart, a.e_endtime examEnd,b.p_endtime PaperEndTime" +
            " from tm_paper b  " +
            " left join tm_examdata a  on a.e_pid = b.p_id  " +
            " left join tm_paper_link_branch plb  on plb.ln_pid = b.p_id " +
            " where plb.ln_buid= #{personId}" +
            " and corp_id = #{corpId}" +
            "<if test= \" paperName != null and paperName != ''\">and b.p_name like concat('%',#{paperName},'%') </if> " +
            "<if test= \" examType != null and examType != '' and examType == '0'.toString()\"> and b.p_id not in(select e_pid from tm_examdata  where e_uid = #{userId})  and now() &gt; b.p_endtime  </if> " +
            "<if test= \" examType != null and examType != '' and examType == '1'.toString()\"> and a.e_status = 2 or a.e_status = 1 </if> " +
            "<if test= \" examType != null and examType != '' and examType == '2'.toString()\"> and b.p_id not in(select e_pid from tm_examdata  where e_uid = #{userId})  and now() &lt; b.p_endtime   </if> " +
            "<if test= \" examType != null and examType != '' and examType == '3'.toString()\"> and a.e_status = 0  </if> " +
            "<if test= \" examResult != null and examResult != '' and examResult == '0'.toString() \"> and  a.e_score &lt; b.p_pass_score </if> " +
            "<if test= \" examResult != null and examResult != '' and examResult == '1'.toString() \"> and  a.e_score &gt;= b.p_pass_score </if> " +
            "<if test= \" scoreStart != null and scoreStart != '' \"> and  a.e_score &gt;= #{scoreStart} </if> " +
            "<if test= \" scoreEnd != null and scoreEnd != '' \"> and a.e_score &lt;= #{scoreEnd}  </if> " +
            "<if test= \" consumeTimeStart != null and consumeTimeStart != '' \"> and TIMESTAMPDIFF(MINUTE, a.e_starttime, a.e_endtime) &gt;= #{consumeTimeStart} </if> " +
            "<if test= \" consumeTimeEnd != null and consumeTimeEnd != '' \"> and TIMESTAMPDIFF(MINUTE, a.e_starttime, a.e_endtime) &lt;= #{consumeTimeEnd}</if> " +
            "<if test= \" examTimeStart != null and examTimeStart != '' \"> and  a.e_starttime  &gt;= #{examTimeStart} </if> " +
            "<if test= \" examTimeEnd != null and examTimeEnd != '' \"> and  a.e_starttime  &lt;= #{examTimeEnd} </if> " +
            "<if test= \" handInTimeStart != null and handInTimeStart != '' \"> and a.e_endtime  &gt;= #{handInTimeStart} </if> " +
            "<if test= \" handInTimeEnd != null and handInTimeEnd != '' \"> and a.e_endtime  &lt;= #{handInTimeStart} </if> " +
            " ORDER BY corp_id " +
            "<if test= \" scoreSort != null and scoreSort != '' and scoreSort == '0'.toString()\">, a.e_score asc </if> " +
            "<if test= \" scoreSort != null and scoreSort != '' and scoreSort == '1'.toString()\">, a.e_score  desc </if> " +
            "<if test= \" examTimeSort != null and examTimeSort != '' and examTimeSort == '0'.toString()\">,a.e_starttime asc  </if> " +
            "<if test= \" examTimeSort != null and examTimeSort != '' and examTimeSort == '1'.toString()\">,a.e_starttime desc  </if> " +
            "<if test= \" handInTimeSort != null and handInTimeSort != '' and handInTimeSort == '0'.toString()\">,a.e_endtime asc  </if> " +
            "<if test= \" handInTimeSort != null and handInTimeSort != '' and handInTimeSort == '1'.toString()\">, a.e_endtime desc </if> " +
            "</script>")
    List<ExamDto> userManageExam(ExamQueryDto dto);
    

}
