package org.rcisoft.business.blesson.dao;

import org.apache.ibatis.annotations.*;
import org.rcisoft.business.blesson.dto.BViewRangeSonDTO;
import org.rcisoft.business.blesson.entity.BViewrangeSon;
import org.rcisoft.core.base.BaseMapper;
import org.rcisoft.business.blesson.entity.BViewrange;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
* Created with  on 2019-9-28 14:19:05.
*/
@Repository
public interface BViewrangeRepository extends BaseMapper<BViewrange> {

    /**
    * 分页查询 bViewrange
    *
    */
    @Select("<script>select * from b_viewrange where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BViewrange> queryBViewranges(BViewrange bViewrange);

    @Update({"<script>",
            "update b_viewrange",
            "  <set>",
            "    <if test='updateBy != null'>update_by=#{updateBy},</if> ",
            "    <if test='updateDate != null'>update_date=#{updateDate},</if> ",
            "    <if test='delFlag != null'>del_flag=#{delFlag},</if> ",
            "    <if test='flag != null'>flag=#{flag},</if> ",
            "    <if test='remarks != null'>remarks=#{remarks},</if> ",
            "    <if test='lessonId != null'>lesson_id=#{lessonId},</if> ",
            "    <if test='type != null'>type=#{type},</if> ",
            "    <if test='corpId != null'>corp_id=#{corpId},</if> ",
            "  </set>",
            "where lesson_id=#{lessonId}",
            "</script>"})
    int updateByLessonId(BViewrange bViewrange);

    @Delete("<script>DELETE from b_viewrange_son where viewrange_id=#{businessId}</script>")
    int deleteViewrangeSon(BViewrange bViewrange);

    @Insert("<script>INSERT INTO b_viewrange_son" +
            "(business_id,viewrange_id,type,target_id,sort)VALUES" +
            "<foreach collection=\"list\" item=\"item\" separator=\",\">" +
            "(#{item.businessId},#{item.viewrangeId},#{item.type},#{item.targetId},#{item.sort})" +
            "</foreach></script>")
    int insertBViewrangeSons(List<BViewrangeSon> bViewrangeSons);


    @Select("<script>select bvs.viewrange_id viewrangeId,bvs.type type,bvs.target_id targetId from b_viewrange_son bvs left join b_viewrange bv on bvs.viewrange_id = bv.business_id " +
            " where 1=1 "+
            " and bv.del_flag != 1 and bv.flag = 1 "+
            " and bv.lesson_id = #{lessonId} "+
            " and bvs.type = 1 "+

            " and bv.corp_id = #{corpId} "+

            " order by CAST(bvs.sort AS UNSIGNED) asc "+
             "</script>")
    List<BViewRangeSonDTO> selectDepartByLessonId(@Param("corpId") String corpId,@Param("lessonId")String lessonId);


    @Select("<script>select bvs.viewrange_id viewrangeId,bvs.type type,bvs.target_id targetId,su.name targetName from b_viewrange_son bvs " +
            " left join b_viewrange bv on bvs.viewrange_id = bv.business_id " +
            " left join s_user su on bvs.target_id = su.business_id " +
            " and su.del_flag != 1 and su.flag = 1 "+

            " and su.corp_id = #{corpId} "+

            " where 1=1 "+
            " and bv.del_flag != 1 and bv.flag = 1 "+
            " and bv.lesson_id = #{lessonId} "+
            " and bvs.type = 0 "+

            " and bv.corp_id = #{corpId} "+

            " order by CAST(bvs.sort AS UNSIGNED) asc "+

            "</script>")
    List<BViewRangeSonDTO> selectPersonByLessonId(@Param("corpId") String corpId,@Param("lessonId")String lessonId);

    @Select("<script>select * from b_viewrange " +
            " where 1=1 "+
            " and lesson_id = #{lessonId} "+
            "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BViewrange> selectByLessonId(String lessonId);
}

