package org.rcisoft.business.blesson.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.Length;
import org.rcisoft.business.bfile.entity.BTrainFile;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.NotBlank;
import java.util.Date;
import java.util.List;

@Data
public class AddLessonDTO {

    @ApiModelProperty(value = "课程id")
    private String businessId;

    @ApiModelProperty(value = "课程编号")
    private String code;

    @NotBlank
    @ApiModelProperty(value = "课程名称",required = true)
    private String lessonName;

    @ApiModelProperty(value = "默认封面图片url")
    private String defaultUrl;

    @ApiModelProperty(value = "课程分类")
    private String courseId;

    @ApiModelProperty(value = "讲师id")
    private String lecturerId;

    @ApiModelProperty(value = "课程描述")
    private String courseDescription;

//    @ApiModelProperty(value = "可见范围")
//    @Length(min = 1,max = 64,message = "长度最小为1,最大为50")
//    private String viewRange;


    @ApiModelProperty(value = "课程类型（0：课程 1：培训）",required = true)
    private String lessonType;

    @ApiModelProperty(value = "消耗积分")
    private Integer valueConsume;

    @ApiModelProperty(value = "获得积分")
    private Integer valueGain;


    @ApiModelProperty(value = "更新积分日期")
    private Date valueUpdateDate;

//    @ApiModelProperty(value = "积分")
//    private String value;

    @ApiModelProperty(value = "标签集合，使用','分隔")
    private String labels;

    @ApiModelProperty(value = "可见范围（人）多人之间用','隔开")
    private String viewRangePerson;

    @ApiModelProperty(value = "可见范围（部门）多人之间用','隔开")
    private String viewRangeDepart;

    //-------培训字段---------
    @ApiModelProperty(value = "培训报名开始时间")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date applyStartDate;

    @ApiModelProperty(value = "培训报名结束时间")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date applyOverDate;

    @ApiModelProperty(value = "培训开始时间")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date trainStartDate;

    @ApiModelProperty(value = "培训结束时间")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date trainOverDate;

    @ApiModelProperty(value = "最大报名人数")
    private String maxApplyPerson;

    @ApiModelProperty(value = "培训地址")
    private String trainAddress;

    @ApiModelProperty(value = "培训签到时间（培训开始前 分钟数）")
    private String trainSignTime;

    @ApiModelProperty(value = "培训附件Json")
    private String trainFileJson;

    @ApiModelProperty(value = "培训附件集合")
    private List<BTrainFile> trainFileList;

    @ApiModelProperty(value = "平台（0 web端 1 客户端和手机端）")
    private String isClient;

}
