package org.rcisoft.business.blesson.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.Length;

import javax.validation.constraints.NotNull;
import java.util.List;

@Data
public class FindListLessonDTO {

    @ApiModelProperty(value = "查询参数",required = false)
    private String viewParam;

    @ApiModelProperty(value = "分类",required = false)
    @Length(min = 1,max = 64,message = "长度最小为1,最大为50")
    private String course;

    @ApiModelProperty(value = "接收标签id")
    private String labelId;

    @ApiModelProperty(value = "发布时间排序（1升序 0降序）",required = true)
    private String releaseDateSort;

    @ApiModelProperty(value = "课程类型 0 课程 1 培训")
    private String lessonType;

    @ApiModelProperty(value = "查询类型 0 全部 1 推荐 2在学 3收藏 4兴趣",required = true)
    @NotNull
    private String searchType;

    private List<String> courseIds;

    private String userId;

    private String corpId;

    private List<String> departs;

}
