package org.rcisoft.business.blesson.dto;


import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.validator.constraints.Length;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;

@Entity
@Table(name = "b_lesson_label")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class ILearnLessonDTO {

    @ApiModelProperty(value = "是否已学完（0：未开始 1：已开始 2： 已学完）")
    private String isFinish;

    @ApiModelProperty(value = "培训状态（0 待参加 1 缺勤 2 已参加 ）")
    private String trainIsSign;

    @Length(min = 1,max = 1,message = "长度最小为1,最大为1")
    @ApiModelProperty(value = "课程类型 0 课程 1 培训")
    private String lessonType;

    @ApiModelProperty(value = "是否为指派课程（0非必修（自选） 1必修（指派））")
    private String isAppoint;

    private String userId;

    private String corpId;

}
