package org.rcisoft.business.blesson.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Transient;
import java.util.Date;

@Data
public class StudentTrackingRspDTO {

    @ApiModelProperty(value = "主键Id")
    private String businessId;

    @ApiModelProperty(value = "课程标题")
    private String LessonTitle;

    @ApiModelProperty(value = "学员id")
    private String personId;

    @ApiModelProperty(value = "学员姓名")
    private String personName;

    @ApiModelProperty(value = "部门名称")
    private String departName;

    @ApiModelProperty(value = "课时")
    private String classHour;

    @ApiModelProperty(value = "课程来源（是否为指派，0自选（选修） 1指派（必修））")
    private String isAppoint;

    @ApiModelProperty(value = "学习状态（0：未开始 1：已开始 2： 已学完")
    private String isFinish;

    @ApiModelProperty(value = "学习进度")
    private String learnProgress;

    @ApiModelProperty(value = "指派时间")
    private Date appointDate;

    @ApiModelProperty(value = "完成时间")
    private Date finishDate;


    @DateTimeFormat(pattern="yyyy/MM/dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy/MM/dd HH:mm:ss")
    @ApiModelProperty(value = "报名时间")
    @Transient
    private Date applyDate;

    @DateTimeFormat(pattern="yyyy/MM/dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8",pattern = "yyyy/MM/dd HH:mm:ss")
    @ApiModelProperty(value = "签到日期")
    @Transient
    private String signDate;

    @ApiModelProperty(value = "培训状态（0 待参加 1 缺勤 2 已签到")
    @Transient
    private String trainIsSign;
    
    @ApiModelProperty(value = "0 未开始 1签到中(进行中) 2已结束")
    private String trainType;


}
