package org.rcisoft.business.blesson.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

@Data
public class UserLessonDTO {

    @ApiModelProperty(value = "课程标题")
    private String lessonTitle;

    @ApiModelProperty(value = "课程类型（0：课程 1：培训）")
    private String lessonType;

    @ApiModelProperty(value = "学习来源（0非必修（自选） 1必修（指派））")
    private String isAppoint;

    @ApiModelProperty(value = "学习状态（0：未开始 1：已开始 2： 已学完）")
    private String isFinish;

    @ApiModelProperty(value = "培训状态（0 待参加 1 缺勤 2 签到 ）")
    private String trainIsSign;

    @ApiModelProperty(value = "0 未开始 1签到中(进行中) 2已结束")
    private String trainType;

    @ApiModelProperty(value = "学习进度最小值")
    private String learnProgressMin;

    @ApiModelProperty(value = "学习进度最大值")
    private String learnProgressMax;

    @ApiModelProperty(value = "指派开始时间")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date appointStartDate;

    @ApiModelProperty(value = "指派结束时间")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date appointEndDate;

    @ApiModelProperty(value = "完成开始时间")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date finishStartDate;

    @ApiModelProperty(value = "完成结束时间")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date finishEndDate;

    @ApiModelProperty(value = "报名筛选开始时间")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date applyStartDate;

    @ApiModelProperty(value = "报名筛选结束时间")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date applyEndDate;

    @ApiModelProperty(value = "签到筛选开始时间")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date signStartDate;

    @ApiModelProperty(value = "签到筛选结束时间")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date signEndDate;


    @ApiModelProperty(value = "指派时间排序（0降序 1升序）",required = false)
    private String appointDateSort;

    @ApiModelProperty(value = "完成时间排序（0降序 1升序）",required = false)
    private String finishDateSort;

    @ApiModelProperty(value = "报名时间排序（0降序 1升序）",required = false)
    private String applyDateSort;

    @ApiModelProperty(value = "签到时间排序（0降序 1升序）",required = false)
    private String signDateSort;

    @ApiModelProperty(value = "学习进度时间排序（0降序 1升序）",required = false)
    private String learnProgressSort;

    @ApiModelProperty(value = "课时排序（0降序 1升序）",required = false)
    private String classHourSort;

    private String corpId;

    private String userId;

}
