package org.rcisoft.business.blesson.service;

import org.rcisoft.business.blesson.dto.*;
import org.rcisoft.business.blesson.entity.BLesson;
import org.rcisoft.core.aop.PageUtil;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.sys.user.bean.CurUser;

import java.util.List;

public interface BLessonPersonService {


    /**
     * 退出课程
     * @param quitLessonDTO
     * @return
     */
    PersistModel quit(QuitLessonDTO quitLessonDTO,CurUser curUser);


    /**
     * 根据条件分页查找我学习的
     * @param pageUtil
     * @param model
     * @return
     */
    List<BLesson> queryLearnBLessonsByPagination(PageUtil pageUtil, ILearnLessonDTO model);

    /**
     * 查询线上课程学员追踪图表
     * @param studentTrackingChartDTO
     * @return
     */
    StudentTrackingChartRspDTO studentTrackingChart(StudentTrackingChartDTO studentTrackingChartDTO);

    /**
     * 学员追踪
     * @param pageUtil
     * @param studentTrackingDTO
     * @return
     */
    List<StudentTrackingRspDTO> studentTrackingByPagination(PageUtil pageUtil, StudentTrackingDTO studentTrackingDTO);

    /**
     * 取消指派
     * @param cancelAppointDTO
     * @return
     */
    PersistModel cancelAppoint(CancelAppointDTO cancelAppointDTO);


    /**
     * 添加我学习课程
     * @author: zhangqingle
     * @param addMyLearnLessonDTO
     * @return
     */
    PersistModel addMyLearnLesson(AddMyLearnLessonDTO addMyLearnLessonDTO, CurUser curUser);
}
