package org.rcisoft.business.bmaterial.service;

import org.rcisoft.business.bmaterial.dto.FindDTO;
import org.rcisoft.business.bmaterial.entity.BMaterial;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.aop.PageUtil;
import org.rcisoft.sys.user.bean.CurUser;

import java.util.List;

/**
 * Created by  on 2019-10-12 10:38:31.
 */
public interface BMaterialService {

    /**
    * 保存 
    * @param bMaterial
    * @return
    */
    PersistModel save(BMaterial bMaterial);

    /**
    * 逻辑删除 
    * @param bMaterial
    * @return
    */
     PersistModel remove(BMaterial bMaterial);

    /**
    * 批量删除
    * @param ids
    * @return
    */
     PersistModel removeMore(String ids, CurUser curUser);

    /**
    * 修改 
    * @param bMaterial
    * @return
    */
    PersistModel merge(BMaterial bMaterial);

    /**
    * 根据id查询 
    * @param id
    * @return
    */
    BMaterial findById(String id);

    /**
    * 分页查询 
    * @param bMaterial
    * @return
    */
    List<BMaterial> findAllByPagination(PageUtil<BMaterial> paginationUtility,
                                        BMaterial bMaterial);

    /**
    * 分页查询 （我的资料）
    * @param findDTO
    * @return
    */
    List<BMaterial> queryMyBMaterialByPagination(PageUtil<BMaterial> paginationUtility,
                                                 FindDTO findDTO);




}
