package org.rcisoft.business.bpersonvalue.controller;


/*固定导入*/
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.collections.map.HashedMap;
import org.bouncycastle.asn1.x509.sigi.PersonalData;
import org.rcisoft.business.bbanner.entity.BBanner;
import org.rcisoft.business.bpersonvalue.dto.PersonValueClientDto;
import org.rcisoft.business.bpersonvalue.dto.PersonValueDto;
import org.rcisoft.common.controller.PaginationController;
import org.rcisoft.common.model.GridModel;
import org.rcisoft.sys.user.bean.CurUser;
import org.springframework.validation.BindingResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import org.rcisoft.core.result.Result;
import org.rcisoft.core.result.ResultServiceEnums;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.util.UserUtil;
import org.rcisoft.core.exception.ServiceException;
import javax.validation.Valid;


import org.rcisoft.business.bpersonvalue.entity.BPersonValue;
import org.rcisoft.business.bpersonvalue.service.BPersonValueService;

import java.util.List;
import java.util.Map;

/**
* Created by  on 2019-11-13 13:28:38.
*/
@Api(tags = "16 用户积分操作")
@RestController
@RequestMapping("bpersonvalue")
public class BPersonValueController extends PaginationController<BPersonValue> {

    @Autowired
    private BPersonValueService bPersonValueServiceImpl;


    @ApiOperation(value = "1601 明细", notes = " type类型（0：获取积分 +，1：消耗积分 -）", response = BPersonValue.class)
    @GetMapping(value = "/queryByPagination")
    public Result queryByPagination(CurUser curUser,@Valid PersonValueClientDto dto ,BindingResult bindingResult) {
        bPersonValueServiceImpl.queryByPagination(getPaginationUtility(),curUser,dto);
        GridModel gridModel = getGridModelResponse();
        return Result.builder(new PersistModel(1),
                MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                gridModel);
    }

    @ApiOperation(value = "1602 添加记录", notes = " 添加记录")
    @GetMapping(value = "/add")
    public Result add (CurUser curUser, @Valid PersonValueDto personValueDto,BindingResult bindingResult) {
        int line = bPersonValueServiceImpl.add(personValueDto,curUser.getCorpId());
        return Result.builder(new PersistModel(line),
                MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                personValueDto);
    }

    @ApiOperation(value = "1603 用户明细带总积分", notes = " 用户明细带总积分", response = BPersonValue.class)
    @GetMapping(value = "/queryPersonValueByPagination")
    public Result queryPersonValueByPagination(CurUser curUser, @Valid PersonValueClientDto dto ,BindingResult bindingResult) {
        bPersonValueServiceImpl.queryByPagination(getPaginationUtility(),curUser, dto);
        GridModel gridModel = getGridModelResponse();
        Map<String,Object> map = new HashedMap();
        map.put("details",gridModel);
        map.put("userValue",bPersonValueServiceImpl.getUserValue(curUser.getCorpId(),curUser.getUserId()));
        return Result.builder(new PersistModel(1),
                MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                map);
    }

}
