package org.rcisoft.business.bpersonvalue.dao;

import org.apache.ibatis.annotations.*;
import org.rcisoft.business.bpersonvalue.dto.PersonValueClientDto;
import org.rcisoft.business.bpersonvalue.dto.PersonValueDto;
import org.rcisoft.core.base.BaseMapper;
import org.rcisoft.business.bpersonvalue.entity.BPersonValue;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
* Created with  on 2019-11-13 13:28:38.
*/
@Repository
public interface BPersonValueRepository extends BaseMapper<BPersonValue> {

    /**
     * 分页查询 bPersonValue
     *
    */
    @Select("<script>" +
            "select * from b_person_value where del_flag != 1 and flag = 1 " +
            "and person_id = #{businessId} " +
            "<if test=\"startTime !=null and startTime != '' \"> and create_date &gt;= #{startTime} </if> "+
            "<if test=\"endTime !=null and endTime != '' \"> and create_date &lt;= #{endTime} </if> "+
            "<if test=\"event !=null and event != '' \"> and `event` like concat('%',#{event},'%') </if> "+
//            "<if test=\"type !=null and type != '' \"> and event like concat('%',#{event},'%') </if> "+

            " ORDER BY person_id " +
            "<if test=\" valueSort !=null and valueSort != '' and valueSort == '0'.toString() \">  ,type asc,`value` desc </if> "+
            "<if test=\" valueSort !=null and valueSort != '' and valueSort == '1'.toString() \">  ,type desc,`value` asc </if> "+
            "<if test=\" dateSort !=null and dateSort != '' and dateSort == '0'.toString() \">  ,create_date asc</if> "+
            "<if test=\" dateSort !=null and dateSort != '' and dateSort == '1'.toString() \">  ,create_date desc</if> "+
            "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BPersonValue> queryBPersonValues(PersonValueClientDto dto);


    @Select("select `value` from s_user where business_id = #{businessId} and del_flag != 1 and flag =1 and corp_id = #{corpId}")
    String getUserValue(@Param("corpId") String corpId, @Param("businessId") String businessId);

    /**
     * 更新s_user表中value
     * @param personId
     * @return
     */
    @Update("<script> update s_user set \n" +
            "`value`= " +
            "((select IFNULL((select sum(`value`) from b_person_value where del_flag != 1 and flag = 1 and type = 0 and person_id = #{personId}) ,0 )) -  " +
            " (select IFNULL((select sum(`value`) from b_person_value where del_flag != 1 and flag = 1 and type = 1 and person_id = #{personId}) ,0 )))" +
            ", lock_num = lock_num+1  " +
            "where business_id = #{personId}" +
            "<if test=\" lockNum !=null \"> and lock_num = #{lockNum} </if> "+
            "</script>")
    int updateUserValue(@Param("personId")String personId,@Param("lockNum")Integer lockNum);

    /**
     * 判断当前积分是否大于扣除积分
     * @param personId
     * @param value
     * @return
     */
    @Select("SELECT ((select IFNULL((select sum(`value`) from b_person_value where del_flag != 1 and flag = 1 and type = 0 and person_id =  #{personId}) ,0 )) -" +
            "(select IFNULL((select sum(`value`) from b_person_value where del_flag != 1 and flag = 1 and type = 1 and person_id =  #{personId}) ,0 ))) - #{value}")
    int judgeUserValue(@Param("personId")String personId,@Param("value")Integer value);

    /**
     * 插入数据
     * @param bPersonValue
     * @return
     */
    @Insert("INSERT INTO b_person_value  " +
            "( remarks,create_by,create_date,update_by,update_date,del_flag,flag,business_id,person_id,`event`,`value`,type )" +
            " VALUES( #{remarks},#{createBy},#{createDate},#{updateBy},#{updateDate},#{delFlag},#{flag},#{businessId},#{personId},#{event},#{value},#{type} )")
    int add(BPersonValue bPersonValue);
}

