package org.rcisoft.business.brstudentchapter.dao;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Update;
import org.rcisoft.business.brstudentchapter.dto.BRStudentChapterDto;
import org.rcisoft.core.base.BaseMapper;
import org.rcisoft.business.brstudentchapter.entity.BRStudentChapter;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
* Created with  on 2019-9-25 10:01:43.
*/
@Repository
public interface BRStudentChapterRepository extends BaseMapper<BRStudentChapter> {


    /**
     * 分页查询 bRStudentChapter
     *
     */
    @Select("<script>select * from b_r_student_chapter where 1=1 "
            + "</script>")
    @ResultMap(value = "BRStudentChapterResultMap" )
    List<BRStudentChapter> queryBRStudentChapters(BRStudentChapter bRStudentChapter);

    /**
     * 根据章节id和学生id查询 学生章节中间表数据
     * @param
     * @return
     */
    @Select("<script>select * from b_r_student_chapter brsc where 1=1 "
            + "<if test=\"chapterId !=null and chapterId != '' \">and brsc.chapter_id = #{chapterId} </if> "
            + "<if test=\"studentId !=null and studentId != '' \">and brsc.student_id = #{studentId} </if> "
            + "</script>")
    @ResultMap(value = "BRStudentChapterResultMap" )
    List<BRStudentChapter> queryByStuIdAndChapter(@Param("chapterId") String chapterId,@Param("studentId") String studentId);

    @Update("UPDATE b_r_student_chapter  " +
            "SET progress = #{progress} ,current_location=#{currentLocation} " +
            "WHERE " +
            " business_id = #{businessId} ")
    @ResultMap(value = "BRStudentChapterResultMap" )
    int updateById(BRStudentChapter brStudentChapter);
}

