package org.rcisoft.business.synchronizationtime.service.impl;

import org.rcisoft.business.synchronizationtime.dao.SynchronizationTimeRepository;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.business.synchronizationtime.entity.SynchronizationTime;
import org.rcisoft.business.synchronizationtime.service.SynchronizationTimeService;


import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;


import lombok.extern.slf4j.Slf4j;

/**
 * Created by  on 2019-10-10 20:04:19.
 */
@Service
@Transactional(readOnly = true,propagation = Propagation.NOT_SUPPORTED)
@Slf4j
public class SynchronizationTimeServiceImpl implements SynchronizationTimeService {

    @Autowired
    SynchronizationTimeRepository synchronizationTimeRepository;

    /**
    * 保存 synchronizationTime
    * @param synchronizationTime
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public PersistModel save(SynchronizationTime synchronizationTime){
        //增加操作
        int line = synchronizationTimeRepository.insertSelective(synchronizationTime);
        return new PersistModel(line);
    }

    @Override
    public SynchronizationTime getById(String id) {
        return synchronizationTimeRepository.getById(id);
    }

    @Override
    public void upadteById(SynchronizationTime synchronizationTime) {
        synchronizationTimeRepository.updateById(synchronizationTime);
    }

}
