package org.rcisoft.common.component;

import com.google.common.collect.Maps;
import lombok.Data;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import java.util.Map;

/**
 * Created with family.
 * author: cy
 * Date: 16/6/2
 * Time: 下午3:50
 * description: global config
 */
@Component
@Data
public class Global {


    /**
     * 保存全局属性值
     */
    static Map<String, String> map = Maps.newHashMap();





    /*服务器保存图片路径*/
    @Value("${global.path.base_upload_server_location}")
    private String BASE_UPLOAD_SERVER_LOCATION;

    /*服务器返回文件路径*/
    @Value("${global.path.return_upload_server_location}")
    private String RETURN_UPLOAD_SERVER_LOCATION;
    /*服务器返回文件路径(无ip端口)*/
    @Value("${global.path.return_upload_server_NOTIP_location}")
    private String RETURN_UPLOAD_SERVER_NOTIP_LOCATION;


    /*课程相关文件路径*/
    @Value("${global.path.course_location}")
    private String COURSE_LOCATION;

    /*课程相关文件路径*/
    @Value("${global.path.user_download}")
    private String USER_DOWNLOAD;

    /*lesson相关文件路径*/
    @Value("${global.path.lesson_location}")
    private String LESSON_LOCATION;

    /*sl相关文件路径*/
    @Value("${global.path.sl_location}")
    private String SL_LOCATION;


    /*服务器上传路径*/
    @Value("${global.path.image_location}")
    private String IMAGE_LOCATION;

    /*视频路径*/
    @Value("${global.path.video_location}")
    private String VIDEO_LOCATION;

    /*音频路径*/
    @Value("${global.path.audio_location}")
    private String AUDIO_LOCATION;

    /*旧视频路径*/
    @Value("${global.path.temp_location}")
    private String TEMP_LOCATION;

    /*附件路径*/
    @Value("${global.path.file_location}")
    private String FILE_LOCATION;

    /*ppt路径*/
    @Value("${global.path.ppt_location}")
    private String PPT_LOCATION;

    /*pdf路径*/
    @Value("${global.path.pdf_location}")
    private String PDF_LOCATION;

    /*切割pdf路径*/
    @Value("${global.path.cut_pdf_location}")
    private String CUT_PDF_LOCATION;

    /*每次切割pdf的页数*/
    @Value("${global.other.cut_pdf_num}")
    private Integer CUT_PDF_NUM;


    /*课程封面路径*/
    @Value("${global.path.cource_logo_location}")
    private String COURSE_LOGO_LOCATION;



    /*是否是服务器（为1代表是服务器）*/
    @Value("${global.other.is_server_linux}")
    private String IS_SERVER_LINUX;


    /*libreoffice ip*/
    @Value("${libreoffice.ip}")
    private String libreofficeIp;

    /*libreoffice 端口*/
    @Value("${libreoffice.port}")
    private Integer libreofficePort;

}
