package org.rcisoft.sys.role.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.Length;

import javax.validation.constraints.NotBlank;

@Data
public class AddOrUpdateRoleDTO {

    @ApiModelProperty(value = "businessId", required = false, dataType = "varchar")
    @Length(min = 1,max = 64,message = "长度最小为1,最大为50")
    private String businessId;

    @ApiModelProperty(value = "角色名称", required = true, dataType = "varchar")
    @Length(min = 1,max = 64,message = "长度最小为1,最大为50")
    @NotBlank
    private String roleName;

    @ApiModelProperty(value = "角色编号", required = false, dataType = "varchar")
    @Length(min = 1,max = 64,message = "长度最小为1,最大为50")
    private String code;

}
